﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public ObservableCollection<ItemModel> Items { get; set; }
        public ObservableCollection<ProductModel> Products { get; set; }

        public MainPage()
        {
            InitializeComponent();
            Items = new ObservableCollection<ItemModel>();
            Products = PopulateProducts();
            DataContext = this;

            Items.Add(new ItemModel(Products) { Product = Products[0] });
        }

        private static ObservableCollection<ProductModel> PopulateProducts()
        {
            var products = new ObservableCollection<ProductModel>
                               {
                                   new ProductModel() {ComboDisplayName = "Product1"},
                                   new ProductModel() {ComboDisplayName = "Product2"},
                                   new ProductModel() {ComboDisplayName = "Product3"},
                                   new ProductModel() {ComboDisplayName = "Product4"}
                               };

            return products;
        }

        private void productCombo_DataObjectRequested(object sender, Infragistics.HandleableObjectGenerationEventArgs e)
        {
            e.NewObject = new ProductModel { ComboDisplayName = "New Object" };
        }
    }

    public class ProductModel
    {
        public string ComboDisplayName { get; set; }
    }

    public class ItemModel
    {
        public ObservableCollection<ProductModel> Products { get; private set; }
        public ItemModel(ObservableCollection<ProductModel> products)
        {
            Products = products;
        }

        public ProductModel Product { get; set; }
        public string Reference { get; set; }
    }
}
